# Функция для вычисления порядка выполнения дел
def order_of_tasks(n, p, queries):
    result = list(p)
    
    for l, r in queries:
        sub_array = p[l-1:r]
        sub_array.sort()
        result[l-1:r] = sub_array
    
    return result

# Чтение входных данных
n, q, k = map(int, input().split())
p = list(map(int, input().split()))
queries = [list(map(int, input().split())) for _ in range(q)]

# Вычисление и вывод результата
result = order_of_tasks(n, p, queries)
print(result[k - 1])
